function love.load()
    gr = love.graphics
    kb = love.keyboard
    mo = love.mouse
    to = love.touch
    wi = love.window

    loadSettings()
    loadImages()
    loadTools()

    w = {
        w = gr.getWidth(),
        h = gr.getHeight()
    }

    animOpened = false
    setAnim(8, 64, 64, 3, 3)-- 8 frames, 16x16 px, frames in a grid of 3x3
end

function love.update(dt)

end

function love.draw()
    gr.clear(0, 0, 0, 0)
    gr.draw(
        imgFrameBackground,
        currentAnim.background,
        currentAnim.x,
        currentAnim.y)

    gr.setCanvas(currentAnim.canvas)
    -- draw stuff in canvas:
    gr.setColor(255, 255, 255, 255)
    
    gr.setCanvas()

    gr.setColor(255, 255, 255, 255)
    gr.draw(
        currentAnim.canvas,
        currentAnim.x,
        currentAnim.y,
        0,
        currentAnim.scale,
        currentAnim.scale
    )
end



---------------------------
---------------------------
-- love api:
---------------------------
---------------------------

function love.mousemoved(x, y, dx, dy, istouch)
    if mo.isDown(1) then-- left click
        currentAnim.canvas:renderTo(function()
            gr.setColor(brush.color)

            local x1 = (x - currentAnim.x) / currentAnim.scale
            local y1 = (y - currentAnim.y) / currentAnim.scale
            local x2 = (x - dx - currentAnim.x) / currentAnim.scale
            local y2 = (y - dy - currentAnim.y) / currentAnim.scale
            
            gr.line(x1, y1, x2, y2)
        end)

        gr.setColor(255, 255, 255, 255)
    end
end






---------------------------
---------------------------
-- animation stuff:
---------------------------
---------------------------

function setAnim(frameNumber, frameW, frameH, gridW, gridH)
    currentAnim = {
        canvas = gr.newCanvas(frameW * gridW, frameH * gridH),
        frameNumber = frameNumber,
        frameW = frameW,
        frameH = frameH,
        gridW = gridW,
        gridH = gridH,
        x = 30,
        y = 20,
        scale = 3
    }

    currentAnim.background = gr.newQuad(
        currentAnim.x,
        currentAnim.y,
        currentAnim.frameW * currentAnim.gridW * currentAnim.scale,
        currentAnim.frameH * currentAnim.gridH * currentAnim.scale,
        imgFrameBackground:getWidth(),
        imgFrameBackground:getHeight()
    )

    function currentAnim:generatePng()
        -- ToDo
    end

    currentAnim:generatePng()

    animOpened = true
end

function loadSettings()
    gr.setLineStyle("rough")
    gr.setLineWidth(1)
    gr.setDefaultFilter("nearest", "nearest")
end

function loadImages()
    imgDir = "/images/"

    imgFrameBackground = gr.newImage(imgDir.."frameBackground.png")

    imgFrameBackground:setWrap("repeat", "repeat")
end

function loadTools()
    brush = {
        color = {255, 127, 0, 255}
    }
end


---------------------------
---------------------------
-- other stuff:
---------------------------
---------------------------

function quit()
    love.event.quit()
end